using FluentValidation;
using CMSMicroservice.Protobuf.Protos.Package;
namespace CMSMicroservice.Protobuf.Validator.Package;

public class DeletePackageRequestValidator : AbstractValidator<DeletePackageRequest>
{
    public DeletePackageRequestValidator()
    {
        RuleFor(model => model.Id)
            .NotNull();
    }
    public Func<object, string, Task<IEnumerable<string>>> ValidateValue => async (model, propertyName) =>
    {
        var result = await ValidateAsync(ValidationContext<DeletePackageRequest>.CreateWithOptions((DeletePackageRequest)model, x => x.IncludeProperties(propertyName)));
        if (result.IsValid)
            return Array.Empty<string>();
        return result.Errors.Select(e => e.ErrorMessage);
    };
}
